poj3126,宽度优先算法

来源:互联网 发布:航天飞机 知乎 编辑:程序博客网 时间:2024/05/07 23:29

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

31033 81791373 80171033 1033

Sample Output

670

Source

Northwestern Europe 2006






#include<iostream>
#include"math.h"
using namespace std;
int sta,goal,shuzi[8999];
struct num
{
int x;
int step;
};
num fdigit[5000],s,t;
bool ifprime(int a)
{
    float aa;
    aa=a;
    int b=int(sqrt(aa));
    int i;
    for(i=2;i<=b;i++){if(a%i==0)return false;}
    return true;
}
///////////////////////
int bfs()
{
    int e,f;e=f=0;
    num s,t;
    fdigit[e++].x=sta;
    memset(shuzi,0,sizeof(shuzi));
    while(e>f)
    {
    s=fdigit[f++];
    if(s.x==goal)return s.step;
    int h1,h2,h3,h4;
    h1=s.x/1000;
    h2=(s.x-1000*h1)/100;
    h3=(s.x-1000*h1-100*h2)/10;
    h4=s.x-1000*h1-100*h2-10*h3;
    
    int i1,i2,i3,i4;
    for(i4=1;i4<=9;i4+=2)
    {t.x=h1*1000+h2*100+h3*10+i4;if(ifprime(t.x)&&t.x!=s.x&&shuzi[t.x-1000]==0)t.step=s.step+1,fdigit[e++]=t,shuzi[t.x-1000]=1;if(t.x==goal)return t.step;}
    for(i3=0;i3<=9;i3++)
    {t.x=h1*1000+h2*100+i3*10+h4;if(ifprime(t.x)&&t.x!=s.x&&shuzi[t.x-1000]==0)t.step=s.step+1,fdigit[e++]=t,shuzi[t.x-1000]=1;if(t.x==goal)return t.step;}
    for(i2=0;i2<=9;i2++)
    {t.x=h1*1000+i2*100+h3*10+h4;if(ifprime(t.x)&&t.x!=s.x&&shuzi[t.x-1000]==0)t.step=s.step+1,fdigit[e++]=t,shuzi[t.x-1000]=1;if(t.x==goal)return t.step;}
    for(i1=1;i1<=9;i1++)
    {t.x=i1*1000+h2*100+h3*10+h4;if(ifprime(t.x)&&t.x!=s.x&&shuzi[t.x-1000]==0)t.step=s.step+1,fdigit[e++]=t,shuzi[t.x-1000]=1;if(t.x==goal)return t.step;}
        

    }return -1;
}

////////////////////////////////
int main()
{
    int n;
    cin>>n;
    while(n--){

    cin>>sta>>goal;
    cout<<bfs()<<endl;
    }
    return 0;
}
0 0
原创粉丝点击